<?php

/**
 * declara_otra_entid actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage declara_otra_entid
 * @author     ManuelEnriqueParedesLopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class declara_otra_entidActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'RVC_DECLARA_OTRA_ENTID',
        'RVC_CONTRATISTA'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'RVC_CONTRATISTA' =>
        array(
            'id_contratista' => 'RVC_DECLARA_OTRA_ENTID'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'RVC_DECLARA_OTRA_ENTID' =>
        array(
            'id_declara_otra_entid' => 'id_declara_otra_entid',
            'id_contratista' => 'id_contratista',
            'fecha' => 'fecha',
            'otra_entidad' => 'otra_entidad',
            'adjunto_firmado' => 'adjunto_firmado',
            'numero_doc' => 'numero_doc',
            'fecha_doc' => 'fecha_doc',
            'observaciones' => 'observaciones',
            'usuario_log' => 'usuario_log',
            'fecha_log' => 'fecha_log',
            'firmado' => 'firmado',
            'fecha_firmado' => 'fecha_firmado',
            'estado' => 'estado'
        ),
        'RVC_CONTRATISTA' =>
        array(
            'tipo_recurso' => 'tipo_recurso',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'razon_social' => 'razon_social',
            'correo' => 'correo',
            'id_ciudad' => 'id_ciudad',
            'estado' => 'estado_contratista',
            'id_tipo_regimen' => 'id_tipo_regimen',
            'mas_empleados' => 'mas_empleados',
            'declarante_renta' => 'declarante_renta',
            'pensionado' => 'pensionado',
            'embargo' => 'embargo',
            'dependiente' => 'dependiente_contra',
            'valor_embargo' => 'valor_embargo_contra',
            'num_doc,||, - ,||,razon_social' => 'completo',
            'otra_entidad' => 'otra_entidad_contra'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * EJEMPLO: 'titular' => array('NULL' => array('titular')),
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'RVC_DECLARA_OTRA_ENTID' => array(
            'id_declara_otra_entid,a' => array('!=' => array(-1)),
            'id_declara_otra_entid,b' => array('=' => array('id_declara_otra_entid')),
            'id_contratista' => array('=' => array('id_contratista')),
            'fecha' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'estado' => array('=' => array(1)),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'num_doc', 'fecha', 'fecha_log', 'otra_entidad'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_declara_otra_entid'; //identificador de la tabla - solo si es un dato no llave compuesta
    protected $id_names = array('id_declara_otra_entid'); //llave primaria
    protected $field_names = array('id_contratista', 'fecha', 'otra_entidad',
        'numero_doc', 'fecha_doc', 'observaciones', 'usuario_log', 'firmado', 'fecha_firmado', 'adjunto_firmado'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'RVC_DECLARA_OTRA_ENTID'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * campos para fecha sistema
     */
//    protected $campo_fecha_sistema = array(
//        'fecha_crea'
//    );

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_declara_otra_entid'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;



        /*
         * Variables request
         */
        $id_contratista = $request['id_contratista'];

        /*
         *  Validar la operación, ya sea por SQL
         */
        $sql = <<<EOD
        select count(*) as cantidad from RVC_DECLARA_OTRA_ENTID
                where id_contratista = $id_contratista
EOD;
        $records = CN_TABLE::executeSQL($sql);

        $declaraciones = $records[0]['cantidad'];

        if ($declaraciones > 0) {
            #ticket 17753 se comenta validacion
            //$errors['mensaje'] = "El contratista ya tiene registrada una declaración juramentada otra entidad";
            //$errors['servicio'] = "declara_otra_entid";
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        $id_declara_otra_entid = $request['id_declara_otra_entid'];

        /*
         *  Validar la operación, ya sea por SQL
         */
        $sql = <<<EOD
select * from rvc_declara_otra_entidet where id_declara_otra_entid = $id_declara_otra_entid  
EOD;
        $records = CN_TABLE::executeSQL($sql);
        /*
         *  Generar errores en $errors
         */
        if (count($records) > 0) {
            $errors['mensaje'] = "No puede eliminar el registro, debe eliminar las entidades del detalle.";
            $errors['servicio'] = "declara_otra_entid";
        }

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $request['usuario_log'] = $request['id_username'];
            //$request['fecha_log'] = CN_TABLE::fechaSistema();
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }
        //accion update
        if ($Action == "UPDATE") {
            
        }
        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    public function executeUpdate(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---function executeUpdate");
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------* Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        $status = 0;
        $records = array();

        /**
         * Abrir nueva conexion con la Base de Datos
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        /*
         * Formato de fecha
         */
        //Sql
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD" 
EOD;
        //Ejecutar SQLvisible
        CN_TABLE::executeSQL($sql);

        try {

            /*
             * Variables de filtro
             */
            $tipo_boton = $request['tipo_boton'];
            $tipo_trans = $request['tipo_trans'];
            $id_declara_otra_entid = $request['id_declara_otra_entid'];

            $usuario_estado = $request['username'];
            $fecha_estado = CN_TABLE::fechaSistema();

            $otra_entidad = $request['otra_entidad'];
            if ($otra_entidad == 'true') {
                $otra_entidad = 1;
            } else {
                $otra_entidad = 0;
            }
            $id_contratista = $request['id_contratista'];

            switch ($tipo_trans) {
                case 1:

                    //Validamos que la declaracion este completa(que no falten dependientes ni adjuntos en las condiciones de dependencia)
                    $declaracion_valida = true;
                    $sql = <<<EOD
select * from rvc_declara_otra_entidet where id_declara_otra_entid = $id_declara_otra_entid  
EOD;
                    //Ejecutar SQL
                    $records = CN_TABLE::executeSQL($sql);

                    if (count($records) == 0) {
                        $declaracion_valida = false;
                    }

                    if ($declaracion_valida == false && $otra_entidad == 1) {//solo valida al ser de otra entidad - 20200518::LAVILA
                        $status = 1;
                        $mensaje = "No es posible firmar. Falta declarar entidades en el detalle.";
                    } else {

                        /**
                         * Consultar Contratista num_doc
                         */
                        //Sql
                        $sql = <<<EOD
select
cont.num_doc,
cont.razon_social,
nov.* 
from rvc_declara_otra_entid nov
join rvc_contratista cont
on nov.id_contratista = cont.id_contratista  
where
1=1 and nov.id_declara_otra_entid = $id_declara_otra_entid  
EOD;
                        //Ejecutar SQL
                        $records = CN_TABLE::executeSQL($sql);
                        $adjunto = "";

                        if (count($records) > 0) {

                            $CODIGOTIMELOG = CN_TABLE::codigoTimeLog();
                            $num_doc = $records[0]['num_doc'];

                            $adjunto = "Doc-$num_doc Formato Otra Entidad $CODIGOTIMELOG.pdf";
                        }


                        //actualizar firmado declaracion, y genera jasper y lo guarda en adjuntos
                        $sql = <<<EOD
update rvc_declara_otra_entid 
set firmado = 1,
fecha_firmado = to_date('$fecha_estado','yyyy-mm-dd'),
adjunto_firmado = '$adjunto'
where
id_declara_otra_entid = $id_declara_otra_entid
EOD;
                        $this->conn->execute($sql);

                        $sql = <<<EOD
update rvc_contratista set otra_entidad = $otra_entidad 
where estado = 1 and id_contratista = $id_contratista 
EOD;
                        $this->conn->execute($sql);
                    }

                    break;

                default:
                    break;
            }

            /*
             * COMMIT DE TODAS LAS TRANSACCIONES
             */
            if ($status == 0) {
                $this->conn->commit();
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage("[declara_otra_entid] Firma exitosa");
            } else {
                $this->conn->rollback();
                $this->status = 1;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
                $this->logMessage("[declara_otra_entid] ERROR!");
                $this->logMessage($mensaje);
            }



            switch ($tipo_trans) {
                case 1:

                    //La certificación debe ser firmada y se adjuntará en los soportes - 20200518
//                    if ($declaracion_valida == true) {

                    /**
                     * Generacion de PDFs jasper - 20180424                             *
                     */
                    $this->logMessage("[CERTIFICACION_FUNC] Generacion de PDFs.\n");

                    $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

                    $int = 0;
                    $url = '';
                    $url_jasper = '';
                    foreach ($array as $routeName => $routeData) {
                        //echo $routeName . "\n";
                        if ('jasper_url' == $routeName) {
                            foreach ($routeData as $key => $value) {
                                //echo $value . "\n";
                                if ($key == 'value') {
                                    $url_jasper = $value;
                                }
                            }
                        }
                        $int++;
                    }


                    //URL de envio inicio
                    $url = $url_jasper;

                    //$url = sfConfig::get('app-gwt_jasper_url');
                    //echo $url;
                    //$ch = curl_init("http://www.sofhouse.net/");
                    /*
                     * $ch = curl_init("http://soporte14.sofhouse.net/jasperphp/whereExecuteReportCartera.php
                     * ?uri=%2Freports%2Fcartera%2Fnota_credito&PARAM_id_credito=33960&PARAM_valor=181480&format=HTML");
                     */
                    $url = $url . 'declara_otra_entid&format=PDF&PARAM_id_mod=24&PARAM_username=websafi&PARAM_nitocc=800189921&PARAM_id_username=946';
                    $url = $url . '&PARAM_id_declara_otra_entid=' . $id_declara_otra_entid;
                    $url = $url . '&PARAM_num_doc=' . $num_doc;
                    $url = $url . '&PARAM_comando=' . 'declara_otra_entid';
                    $url = $url . '&PARAM_comando_inf=' . 'declara_otra_entid';

                    $url = $url . '&PARAM_tag_img_firma=1';
                    $url = $url . '&PARAM_envio_correo=false&PARAM_tag_adjunto_modulo=true';
                    $url = $url . '&PARAM_nombre_reporte=' . str_replace(' ', ':', $adjunto);

                    //echo $url;
                    //die();
                    $this->logMessage($url);
                    $ch = curl_init($url);

                    //Parametros de retorno en cURL
                    curl_setopt($ch, CURLOPT_HEADER, 0);
                    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // Skip SSL Verification
                    //Ejecuta la petición
                    $rta = curl_exec($ch);
                    //Se cierra la conexión
                    curl_close($ch);

                    //                $arrayRespuesta = json_decode($rta, true);
                    //Verifica el status, si es diferente de 0, ocurrio un error 
                    //                if ($arrayRespuesta['response']['status'] != 0) {
                    //                    $this->logMessage("[Error] Me llamo desde el CURL");
                    //echo "<h3>Me llamo desde el cURL</h3>";
                    //              $mensaje=$arrayRespuesta['response']['data'];
                    //              $this->status = 3;
                    //              $a = $mensaje[0]['mensaje'];
                    //              $b = htmlspecialchars($a, ENT_QUOTES);
                    //              $this->mensajeError = $b;
                    //              $this->list_data = array();
                    //                }

                    /*
                     * FIN Generacion de PDFs
                     */
//                    }


                    break;

                default:
                    break;
            }
        } catch (Exception $ex) {

            /*
             * ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
             */
            $this->conn->rollback();
            $this->status = 1;
            $this->mensajeError = "[declara_otra_entid] Ocurrio un error: " . $e->getMessage();
            $this->list_data = array();
            $this->logMessage("[declara_otra_entid] ERROR!");
            $this->logMessage($e->getMessage());
        }
    }

}
